Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices
Imports System.Text

Friend Class Form1
	Inherits System.Windows.Forms.Form


    <DllImport("rp2005.dll")> _
           Private Shared Function RP_ListDIO(ByRef NumDevices As Integer, ByVal SNList As StringBuilder, ByVal DscList As StringBuilder) As Integer
    End Function
    <DllImport("rp2005.dll")> _
           Private Shared Function RP_OpenDIO(ByVal SN As String, ByRef hDIO As Integer) As Integer
    End Function

    <DllImport("rp2005.dll")> _
           Private Shared Function RP_ReadPort(ByVal hDIO As Integer, ByVal portNum As Byte, ByRef portData As Byte, ByVal errMsg As StringBuilder) As Integer
    End Function
    <DllImport("rp2005.dll")> _
           Private Shared Function RP_WritePort(ByVal hDIO As Integer, ByVal portNum As Byte, ByVal portData As Byte, ByVal errMsg As StringBuilder) As Integer
    End Function
    <DllImport("rp2005.dll")> _
           Private Shared Function RP_CloseDIO(ByVal hDIO As Integer) As Integer
    End Function

    '	Private Declare Function RP_CloseDIO Lib "RP2005.dll" (ByVal hDIO As Integer) As Integer


    Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click
        Dim iError As Integer
        Dim iNumDevs As Short
        Dim tmpSNList As StringBuilder
        Dim tmpDscList As StringBuilder
        Dim SNList As String
        Dim DscList As String
        Dim a_strResult As Object
        Dim i As Short

        tmpSNList = New StringBuilder(513)
        tmpDscList = New StringBuilder(1025)
        SNList = New String(vbNullChar, 513)
        DscList = New String(vbNullChar, 1025)

        ' Get the number of boards, the serial numbers
        ' of the boards, and the board descriptions.
        iError = RP_ListDIO(iNumDevs, tmpSNList, tmpDscList)
        If iError = 0 Then

            Text2.Text = CStr(iNumDevs)


            ' split the board serial numbers into an array.
            ' The board serial numbers are delimited by
            ' commas
            'UPGRADE_WARNING: Couldn't resolve default property of object a_strResult. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
            SNList = tmpSNList.ToString
            DscList = tmpDscList.ToString

            a_strResult = Split(SNList, ",")

            List1.Items.Clear()

            ' Add the serial number string(s) to the
            '"Selected Device" combo box.
            For i = 0 To UBound(a_strResult)
                List1.Items.Add((a_strResult(i)))
            Next i

            ' split the board descriptions into an array.
            ' The board descriptions are delimited by
            ' commas
            'UPGRADE_WARNING: Couldn't resolve default property of object a_strResult. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
            a_strResult = Split(DscList, ",")

            List2.Items.Clear()

            ' Add the board description string(s) to the
            '"Device Description" combo box.
            For i = 0 To UBound(a_strResult)
                List2.Items.Add((a_strResult(i)))
            Next i
        Else
            Text1.Text = "Error"
        End If

    End Sub

    Private Sub InputPorts_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles InputPorts.Click
        Dim iError As Integer
        Dim pval As Byte
        Dim errMsg As StringBuilder
        Dim hDIO As Integer
        Dim SN As String

        SN = New String(vbNullChar, 100)
        errMsg = New StringBuilder(513)
        SN = VB6.GetItemString(List1, 0)

        iError = RP_OpenDIO(SN, hDIO)
        If (iError = 0) Then

            iError = RP_ReadPort(hDIO, 0, pval, errMsg)
            If (iError = 0) Then
                Text3.Text = CStr(pval)
            Else
                Text1.Text = errMsg.ToString
                RP_CloseDIO(hDIO)
            End If

            iError = RP_ReadPort(hDIO, 1, pval, errMsg)
            If (iError = 0) Then
                Text4.Text = CStr(pval)
            Else
                Text1.Text = errMsg.ToString
                RP_CloseDIO(hDIO)
            End If

            ' read port 10hex (second output port)
            iError = RP_ReadPort(hDIO, 16, pval, errMsg)
            If (iError = 0) Then
                Text5.Text = CStr(pval)
            Else
                Text1.Text = errMsg.ToString
                RP_CloseDIO(hDIO)
            End If

            ' read port 11 hex (second output port)
            iError = RP_ReadPort(hDIO, 17, pval, errMsg)
            If (iError = 0) Then
                Text6.Text = CStr(pval)
            Else
                Text1.Text = errMsg.ToString
                RP_CloseDIO(hDIO)
            End If
            RP_CloseDIO(hDIO)
        Else
            Text1.Text = "RP_OPENDIO Error"
        End If
    End Sub

    Private Sub OutputPorts_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles OutputPorts.Click
        Dim iError As Integer
        Dim pval As Byte
        Dim errMsg As StringBuilder
        Dim hDIO As Integer
        Dim SN As String

        SN = New String(vbNullChar, 100)
        errMsg = New StringBuilder(513)
        SN = VB6.GetItemString(List1, 0)

        iError = RP_OpenDIO(SN, hDIO)
        If (iError = 0) Then

            pval = CByte(Text5.Text)
            iError = RP_WritePort(hDIO, 16, pval, errMsg)
            If iError <> 0 Then Text1.Text = "port 0 write error: " & errMsg.ToString

            pval = CByte(Text6.Text)
            iError = RP_WritePort(hDIO, 17, pval, errMsg)
            If iError <> 0 Then Text1.Text = "port 1 write error: " & errMsg.ToString


            RP_CloseDIO(hDIO)
        Else
            Text1.Text = "RP_OPENDIO Error"
        End If



    End Sub
End Class